<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">
var debug = false;
var currentStep = 1;

var pdfIsValid = false;
var mrnaDateIsValid = false;
var commentsIsValid = false;

function init()
{
	var frm = document.forms['reggie'];
	var bioplates = getMRnaBioPlates();
	
	// Load existing mRNA plates not yet registered
	var plates = frm.bioplate;
	if (bioplates != null && bioplates.length > 0)
	{
		for (var i=0; i < bioplates.length; i++)
		{
			var bioplate = bioplates[i];
			var option = new Option(bioplate.name, bioplate.id);
			option.comments = bioplate.comments;
			plates.options[plates.length] = option;
		}
		bioplateIsValid = true;
		setInputStatus('bioplate', '', 'valid');
		bioPlateOnChange();
		outcomeOnChange();
	}
	else
	{
		var msg = 'No mRNA bioplates available for processing.';
		setFatalError(msg);
		return;
	}

	// All is ok
	frm.bioplate.focus();
}


function goNextAuto()
{
	goNext(false);
}

function goNext(manual)
{
	setInnerHTML('gonext.message', '');
	if (currentStep == 1)
	{		
		gotoStep2();
	}
	setCurrentStep(currentStep);
}



function getMRnaBioPlates()
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading histology work lists...');
		var url = '../MRna.servlet?ID=<%=ID%>&cmd=GetUnprocessedPlates&plateType=MRNA';		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.bioplates;
}

function gotoStep2()
{
	var frm = document.forms['reggie'];	
	frm.bioplate.disabled = true;
	frm.outcome[0].disabled = true;
	frm.outcome[1].disabled = true;

	
	currentStep = 2;
	Main.show('step.2.section');
	Main.addClass(document.getElementById('step.1.section'), 'disabled');
	Main.hide('gonext');
	Main.show('gocancel');
	Main.show('goregister');
	
	// Load mRNA protocols
	var mrnaProtocols = getProtocols('MRNA_PROTOCOL');
	for (var i = 0; i < mrnaProtocols.length; i++)
	{
		var protocol = mrnaProtocols[i];
		frm.mrnaProtocol[frm.mrnaProtocol.length] = new Option(protocol.name, protocol.id, protocol.isDefault);
		setInputStatus('mrnaProtocol', '', 'valid');
	}
	if (frm.mrnaProtocol.length == 0)
	{
		frm.mrnaProtocol[0] = new Option('- none -', '');
	}

	frm.mrnaDate.focus();
}

function getProtocols(subtype)
{
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading ' + subtype + ' protocols...');
		var url = '../Protocol.servlet?ID=<%=ID%>&cmd=GetProtocols&subtype='+subtype;		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.protocols;
}

function bioPlateOnChange()
{
	var frm = document.forms['reggie'];
	frm.comments.value = frm.bioplate[frm.bioplate.selectedIndex].comments;
	commentsOnChange();
}

function outcomeOnChange()
{
	var frm = document.forms['reggie'];
	Main.addOrRemoveClass(frm['pdf.path'], 'required', document.getElementById('outcomeSuccess').checked);
	Main.addOrRemoveClass(frm['comments'], 'required', document.getElementById('outcomeFailed').checked);
	pdfFileOnChange();
	commentsOnChange();
}

function browseOnClick(extension)
{
	var frm = document.forms['reggie'];
	if (frm[extension+'.path'].disabled) return;
	
	var url = getRoot() + 'filemanager/index.jsp?ID=<%=ID%>&cmd=SelectOne&callback=setFileCallback';
	url += '&resetTemporary=1&tmpfilter:STRING:name='+escape('%.' + extension.substr(0, 3));
	lastExtension = extension;
	Main.openPopup(url, 'SelectFile', 1000, 700);
}

function setFileCallback(id, path)
{
	var frm = document.forms['reggie'];
	frm[lastExtension+'.id'].value = id;
	frm[lastExtension+'.path'].value = path;
	setInputStatus(lastExtension, '', 'valid');
	if (lastExtension == 'pdf')
	{
		pdfIsValid = true;
	}
}

function pdfFileOnChange()
{
	var frm = document.forms['reggie'];
	if (!frm['pdf.id'].value)
	{
		var outcomeSuccess = document.getElementById('outcomeSuccess');
		pdfIsValid = false;
		// A PDF is reuired for successful registration, optional after a failure
		var status = outcomeSuccess.checked ? 'invalid' : 'warning';
		if (!frm['pdf.path'].value)
		{
			setInputStatus('pdf', 'Missing', status);
			pdfIsValid = !outcomeSuccess.checked;
		}
		else
		{
			setInputStatus('pdf', 'Use the Browse button to select a file', 'invalid');
		}
	}
}

function mrnaDateOnChange()
{
	var frm = document.forms['reggie'];
	mrnaDateIsValid = false;
	setInputStatus('mrnaDate', '', '');
	
	var mrnaDate = frm.mrnaDate.value;
	
	if (mrnaDate == '')
	{
		setInputStatus('mrnaDate', 'Missing', 'invalid');
		return;
	}

	// Auto-fill the date if it's only given with 4(MMdd) or 6(yyMMdd) digits.		
	mrnaDate = autoFillDate(mrnaDate);
	frm.mrnaDate.value = mrnaDate;
	
	if (!Dates.isDate(mrnaDate, 'yyyyMMdd'))
	{
		setInputStatus('mrnaDate', 'Not a valid date', 'invalid');
		return;
	}
	
	setInputStatus('mrnaDate', '', 'valid');
	mrnaDateIsValid = true;
}

function commentsOnChange()
{
	var frm = document.forms['reggie'];
	commentsIsValid = false;
	setInputStatus('comments', '', '');
	
	var comments = frm.comments.value;
	
	if (comments == '' && document.getElementById('outcomeFailed').checked)
	{
		setInputStatus('comments', 'Missing', 'invalid');
		return;
	}

	setInputStatus('comments', '', 'valid');
	commentsIsValid = true;
}

function goRegister()
{
	if (!mrnaDateIsValid || !pdfIsValid || !commentsIsValid) return;

	var frm = document.forms['reggie'];
	var pdfId = parseInt(frm['pdf.id'].value, 10);
	
	Main.hide('goregister');
	Main.hide('gocancel');
	Main.addClass(document.getElementById('step.2.section'), 'disabled');

	frm['pdf.path'].disabled = true;
	Main.addClass(document.getElementById('btnPdf'), 'disabled');
	frm.mrnaOperator.disabled = true;
	frm.mrnaProtocol.disabled = true;
	frm.mrnaDate.disabled = true;
	frm.comments.disabled = true;
	
	var submitInfo = {};
	submitInfo.bioplate = parseInt(frm.bioplate.value, 10);
	submitInfo.mrnaProtocol = parseInt(frm.mrnaProtocol.value, 10);
	submitInfo.failed = document.getElementById('outcomeSuccess').checked ? false : true;
	submitInfo.pdf = pdfId;
	submitInfo.mrnaDate = frm.mrnaDate.value;
	submitInfo.mrnaOperator = frm.mrnaOperator.value;
	submitInfo.comments = frm.comments.value;
	
	if (debug) Main.debug(JSON.stringify(submitInfo));
	var url = '../MRna.servlet?ID=<%=ID%>&cmd=ImportMRnaQCResults';
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Performing registration...');
		request.open("POST", url, false);
		request.send(JSON.stringify(submitInfo));
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);
	
	if (response.messages && response.messages.length > 0)
	{
		var msg = '<ul>';
		for (var i = 0; i < response.messages.length; i++)
		{
			var msgLine = response.messages[i];
			if (msgLine.indexOf('[Warning]') >= 0)
			{
				msg += '<li class="warning">' + msgLine.replace('[Warning]', '');
			}
			else
			{
				msg += '<li>' + msgLine;
			}
		}
		msg += '</ul>';
		setInnerHTML('messages', msg);
		Main.show('messages');
	}
	
	if (response.status != 'ok')
	{
		Main.addClass(document.getElementById('messages'), 'failure');
		setFatalError(response.message);
		return false;
	}

	Main.show('gorestart');	
}


</script>

</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="mRNA registration and quality control results" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</div>
		<%
	}
	%>

	<form name="reggie" onsubmit="return false;">
		<input type="hidden" name="pdf.id" value="">
	
	<div id="step.1.section">
	<table class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Select mRNA bioplate</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table>
			<tr valign="top">
				<td class="prompt">mRNA bioplate</td>
				<td class="input"><select class="required" style="width:90%;" 
						name="bioplate" id="bioplate" onchange="bioPlateOnChange()"></select>
				</td>
				<td class="status" id="bioplate.status"></td>
				<td class="help"><span id="bioplate.message" class="message" style="display: none;"></span>
					Select an existing mRNA bioplate. The list contain all mRNA bioplates that
					has not yet been processed (determined by the absence of a 'creation' date).
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Outcome</td>
				<td class="input">
					<input type="radio" name="outcome" id="outcomeSuccess" 
						onchange="outcomeOnChange()" checked><label for="outcomeSuccess">Success</label> - continue processing to cDNA<br>
					<input type="radio" name="outcome" id="outcomeFailed" 
						onchange="outcomeOnChange()"><label for="outcomeFailed">Failure</label> - no further processing to cDNA
				</td>
				<td class="status"></td>
				<td class="help">
					Select the <b>Failure</b> option if further processing to cDNA is not possible.
					No child cDNA plate will be created and existing RNA will be flagged and added
					to the <b>Flagged RNA</b> list.
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	</div>
	
	<div id="step.2.section" style="display: none;">
	<table class="stepform">
	<tr>
		<td rowspan="3" class="stepno">2</td>
		<td class="steptitle">mRNA results</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table>
			<tr valign="top">
				<td class="prompt">Date</td>
				<td class="input">
					<input type="text" class="required" name="mrnaDate" value="" size="12" maxlength="10"
						onblur="mrnaDateOnChange()" onkeypress="focusOnEnter(event, 'pdf.path')">
				</td>
				<td class="status" id="mrnaDate.status"></td>
				<td class="help">
					<span id="mrnaDate.message" class="message" style="display: none;"></span>(YYYYMMDD or MMDD)
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">PDF file</td>
				<td class="input">
					<table>
					<tr>
					<td><input class="text required" type="text" 
						name="pdf.path" value=""
						size="50" onkeypress="doOnEnter(event, function(){document.getElementById('btnPdf').click()})"
						onblur="pdfFileOnChange()"
						></td>
					<td style="padding-left: 4px;"><base:button 
							title="Browse&hellip;"
							onclick="browseOnClick('pdf')"
							id="btnPdf"
							/>
					</td>
					</tr>
					</table>
				</td>
				<td class="status" id="pdf.status"></td>
				<td class="help"><span id="pdf.message" class="message" style="display: none;"></span>
					Select the PDF file that contains a printout with diagrams and other
					useful documentation.
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Protocol</td>
				<td class="input"><select style="width:90%" name="mrnaProtocol" id="mrnaProtocol" 
					onkeypress="focusOnEnter(event, 'mrnaOperator')"></select></td>
				<td class="status" id="mrnaProtocol.status"></td>
				<td class="help"><span id="mrnaProtocol.message" class="message" style="display: none;"></span>
					Select the protocol which was used in the mRNA step.
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Operator</td>
				<td class="input">
					<input type="text" name="mrnaOperator" value="<%=HTML.encodeTags(user.getName()) %>" 
						style="width: 90%;" maxlength="255" onkeypress="focusOnEnter(event, 'comments')">
				</td>
				<td class="status" id="mrnaOperator.status"></td>
				<td class="help">
					<span id="mrnaOperator.message" class="message" style="display: none;"></span>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Comments</td>
				<td class="input"><textarea rows="4" cols="50" style="width: 90%;" name="comments" value="" onblur="commentsOnChange()"></textarea></td>
				<td class="status" id="comments.status"></td>
				<td class="help"><span id="comments.message" class="message" style="display: none;"></span>Comments about the mRNA processing.</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	</div>
	
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="../images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="messages" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>
	
	<table style="margin-left: 20px; margin-top: 10px;" class="navigation">
		<tr>
			<td><base:button id="gocancel" title="Cancel" onclick="goRestart(false)" style="display: none;"/></td>
			<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" onclick="goNext(true)"/></td>
			<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>" onclick="goRegister()" style="display: none;"/></td>
			<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
			<td id="gonext.message" class="message"></td>
		</tr>
	</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>